//#define NDEBUG
#include <cassert> 
#include "Cjt_estudiants.hh"
#include <algorithm>


Cjt_estudiants::Cjt_estudiants() {
  nest = 0;
  vest = vector<Estudiant>(MAX_NEST);
}
  
 
int Cjt_estudiants::cerca_dicot(const vector<Estudiant>& v, int left, int right, int x) {
/* Pre: v esta ordenat */
  int i;
  bool found = false;
  while (left <= right and not found) { 
    i = (left + right)/2;
    if (x < v[i].consultar_DNI()) right = i - 1;
    else if (x > v[i].consultar_DNI()) left = i + 1; 
    else found = true;
  }
  // i es la posicio, si l'element existeix
  if (found) return i; 
  else return left;  
}  
  		

void Cjt_estudiants::modificar_iessim(int i, const Estudiant& est) {
  assert(1 <= i and  i <= nest and "Index no valid per a modificar_iessim");
  
  vest[i-1] = est;
}


int Cjt_estudiants::mida() const {
  return nest;
}


int Cjt_estudiants::mida_maxima() {
  return MAX_NEST;
}


bool Cjt_estudiants::existeix_estudiant(int dni) const {
  int i= cerca_dicot(vest,0,nest-1,dni);
  return (i != -1);
}



Estudiant Cjt_estudiants::consultar_iessim(int i) const {
  assert(1 <= i and i <= nest and "Index no valid per a consultar_iessim");
  
  return vest[i-1];
}



void Cjt_estudiants::ordenar_cjt_estudiants() {
  sort(vest.begin(), vest.begin() + nest, Estudiant::menor_dni);
}


void Cjt_estudiants::llegir() {
  cin >> nest;

  assert(nest <= MAX_NEST and "El conjunt no pot ser mes gran que la mida maxima");

  for (int i = 0; i < nest; ++i)
    vest[i].llegir();
  ordenar_cjt_estudiants();
}


void Cjt_estudiants::escriure() const {
  for (int i = 0; i < nest; ++i)
    vest[i].escriure();
}
